package Model;
import java.awt.Color;
import java.awt.Graphics;
import java.util.LinkedList;
import javax.swing.UIManager;

import APP.APP;

public class MujJedinec extends Jedinec {
	// chromozom je kdovn v celch sel a to
	// 0 pro doleva , 1 pro nahoru, 2 pro doprava a 3 pro dol
	
	// promn
	public Pozice pozice;
	private int naAlele = 0;// promn pro vykreslovn a pro hodnotc funkci

	// fce
	@Override
	public boolean ohodnocujiciFunkce(){// bere v potaz vzdlenosti mezi souasnou pozic, vlem a startem
		while (this.pohyb()) {};
		double a = (double) (Math.abs(pozice.x - Bludiste.start.x) + Math.abs(pozice.y - Bludiste.start.y));
		double b = (double) (Math.abs(Bludiste.cil.x - pozice.x) + Math.abs(Bludiste.cil.y - pozice.y));
		if(b == 0){ // nastane pouze pokud jsme v cli
			this.fitnes = -1.0;
			return true; // jsme v cli
		}else {
			this.fitnes = a / b;	
			return false; // nejsme v cli
		}
	}
			
	@Override
	public String toString() { // systmov vpis
		String navrat = "Jedinec " + this.ID + " s chromozomem: ";
		for (Object o : chromosom) {
			navrat += ((Integer) (o)).toString() + ", ";
		}
		navrat = navrat.substring(0, navrat.length() - 2);
		navrat += " m fitnes: " + this.fitnes;
		return navrat;
	}
	
	public void vyskesliCelouCestu(Graphics graphics, int width, int height) { // vykreslen
		int indexX = width / Bludiste.width;
		int indexY = height / Bludiste.height;
		graphics.setColor(new Color(0, 0, 255));
		graphics.fillRect(pozice.x/2 * indexX+5, pozice.y/2*indexY+5, indexX-10, indexY-10);
		while(this.pohyb()){
			graphics.fillRect(pozice.x/2 * indexX+5, pozice.y/2*indexY+5, indexX-10, indexY-10);
		}
	}
	public void vymazCestu(Graphics graphics, int width, int height) { // vymae se
		int indexX = width / Bludiste.width;
		int indexY = height / Bludiste.height;		
		graphics.setColor(UIManager.getColor("Panel.background"));
		pozice = new Pozice(Bludiste.start);
		naAlele = 0;
		while(this.pohyb()){
			graphics.fillRect(pozice.x/2 * indexX+5, pozice.y/2*indexY+5, indexX-10, indexY-10);
		}
	}

	public boolean pohyb() { // pohybovn podle chromozomu - true kdy jet nen na konci chromozomu, a false kdy je - zmn aktuln pozici
		if (chromosom.size() > naAlele) {
			switch ((int) (chromosom.get(naAlele))) {
			case 0:
				doleva();
				break;
			case 1:
				nahoru();
				break;
			case 2:
				doprava();
				break;
			case 3:
				dolu();				
				break;

			default:
				break;
			}				
			naAlele++;
			return true;
		}
		return false;
	}


	private void dolu() { // pohyb dol
		pozice.y++;
		if(APP.bludiste.jsouZdeDvere(pozice)){
			pozice.y++;
		}else{
			pozice.y--;			
		}
	}

	private void doprava() { // pohyb doprava
		pozice.x++;
		if(APP.bludiste.jsouZdeDvere(pozice)){
			pozice.x++;
		}else{
			pozice.x--;			
		}		
	}

	private void nahoru() { // pohyb nahoru
		pozice.y--;
		if(APP.bludiste.jsouZdeDvere(pozice)){
			pozice.y--;
		}else{
			pozice.y++;			
		}
	}

	private void doleva() { // pohyb doleva
		pozice.x--;
		if(APP.bludiste.jsouZdeDvere(pozice)){
			pozice.x--;
		}else{
			pozice.x++;			
		}
	}

	// konstruktory
	public MujJedinec(LinkedList<Object> chromosom,Pozice p) {
		super(chromosom);
		init(p);
	}

	public MujJedinec(LinkedList<Object> chromosom, int ID,Pozice p) {// pro konstruktor mutace, aby se nepidlovalo nov ID
		super(chromosom, ID);
		init(p);
	}

	public MujJedinec() {
		super();
	}
	public MujJedinec(MujJedinec m,Pozice p){//konstruktor pro jedince, kter se bude vykreslovat, aby nedochzelo k null pointer exception
		super();
		this.chromosom = new LinkedList<>();
		this.chromosom.addAll(m.chromosom);
		this.ID = m.ID;
		this.naAlele = 0;
		this.fitnes = m.fitnes;
		init(p);
	}

	private void init(Pozice p) {//nastaven  polohy
		pozice = new Pozice(p);
	}
}
