package Model;
import java.util.LinkedList;
import java.util.Random;

import APP.APP;

public class Populace {	
	
	//promnn
	public LinkedList<Jedinec> generace; //uchovvn populace
	protected Random ran = new Random();
	// <-- promnn
	
	//fce
	protected void ohodnotitPopulaci() { // ohodnot celou populaci, pokud nenaraz na vsledek
		for (Jedinec jedinec : generace) {
			APP.volaniFitnessFunkce++; // pro mc ely
			if (jedinec.ohodnocujiciFunkce()) {
				APP.reseni = new MujJedinec((MujJedinec) (jedinec), Bludiste.start);
				break;
			}
		}
	}
	public double celkoveFitnessPopulace(){ // vrt souet fitness vechn jedinc
		double hodnoceni = 0.0;
		for(Jedinec jedinec:generace){
			hodnoceni += jedinec.fitnes;
		}
		return hodnoceni;
	}
	public MujJedinec getNejlepsiJedinec(){ // vrt jedince, jeho fitness je nejvy
		MujJedinec j = new MujJedinec((MujJedinec)(generace.getFirst()), Bludiste.start);
		for (int i = 1; i < generace.size(); i++) {
			if(j.fitnes < generace.get(i).fitnes){
				j = new MujJedinec((MujJedinec)(generace.get(i)),Bludiste.start);
			}
		}
		return j;
	}
	private LinkedList<Jedinec> zvetsitChromozomyOJeden(LinkedList<Jedinec> seznam1){ // kadmu jedinci pd na konec chromozomu novou alelu
		APP.veliksotChromosomu++;
		LinkedList<Jedinec> seznam2 = new LinkedList<>();
		for(Jedinec jedinec: seznam1){
			jedinec.chromosom.add((Object)(ran.nextInt(4)));
			seznam2.add(new MujJedinec((MujJedinec)(jedinec),Bludiste.start));
		}
		return seznam2;		
	}
	//selekn mechanizmy
	protected LinkedList<Jedinec> ruletovaSelekce(int pocet, LinkedList<Jedinec> kSelekci){ // funkce vrt seznam vybranch jedinu dlky 2x pocetDvojc podle ruletov selkce s pravdpodobnost pmo umrn fitnes jedince
		LinkedList<Jedinec> seznam = new LinkedList<>(); // seznam dvojc
		double fitnessCelePopulace = celkoveFitnessPopulace(); //vpoty pro pian sprvn pravdpodobnosti
		double jedenDilek = 1.0 / fitnessCelePopulace;
		double celkoveOhodnoceni = 0; // po skonen nsledujcch cykl by se hodnota mla rovnat nebo velice blit slu 1.0 - musme vdy posunout na rulet jedince hned za toho dalho
		for(Jedinec jedinec : kSelekci){ // piazen hodnoty kadmu jedinci
			celkoveOhodnoceni = jedinec.ohodnoceniProRuletovouSelekci = celkoveOhodnoceni + jedenDilek * jedinec.fitnes;
		}
		for(int i = 0; i<pocet;i++){ // naplovn seznamu dvojc
			double o = ran.nextDouble(); // roztoen rulety
			int p; // index pro porchzen generace
			for(p = 0; p < kSelekci.size(); p++){ 
				if(o < kSelekci.get(p).ohodnoceniProRuletovouSelekci){ // dokud nenarazim na jedince, jeho ohodnocen pro ruletu je vt ne kam dopadla kulika, tedy kulika musela dopadnout pednim(v jeho teritorium) a jeliko se tome postupn(ohodnocen jedinc je vzrstajc), tak vdycky narazme na sprvnho jedince
					break;
				}
			}
			if(p == kSelekci.size()){// pojistka, kdyby posledn jedinec ml pravdpodobnost men, ne kolik padlo na rulet
				p--;				
			}
			seznam.add(kSelekci.get(p));
		}		
		return seznam;
	}
	//<-- selekn mechanizmy
	
	//kc mechanizmy	
	protected LinkedList<Jedinec> jednobodoveKrizeniProStejneDlouheChromozomy(LinkedList<Jedinec> keKrizeni){ // ze seznamu z parametru vrac novou nakenou populaci(vybr po dvojicch jak jdou zasebou)
		LinkedList<Jedinec> seznam = new LinkedList<>();
		int pozice; // na tomto mst se bude dlit(bude hodnota pt, prvn st chromozomu bude od 0 - 4 ze prvnho rodie, druh st 5 - n z druhho rodie)
		LinkedList<Object> chromosom = new LinkedList<>();
		
		for(int i = 0; i < keKrizeni.size(); i+=2){
			pozice = ran.nextInt(keKrizeni.get(0).chromosom.size());// kde se bude kit
			
			//jeden potomek
			chromosom = new LinkedList<>();
			chromosom.addAll(keKrizeni.get(i).chromosom.subList(0, pozice));
			chromosom.addAll(keKrizeni.get(i+1).chromosom.subList(pozice, keKrizeni.get(0).chromosom.size()));
			seznam.add(new MujJedinec(chromosom, Bludiste.start));

			//druhy potomek
			chromosom = new LinkedList<>();
			chromosom.addAll(keKrizeni.get(i+1).chromosom.subList(0, pozice));
			chromosom.addAll(keKrizeni.get(i).chromosom.subList(pozice, keKrizeni.get(0).chromosom.size()));
			seznam.add(new MujJedinec(chromosom, Bludiste.start));
		}		
		return seznam;
	}
		
	protected LinkedList<Jedinec> mutace(LinkedList<Jedinec> kMutaci, double pravdepodobnost){// mutace s pravdpodobnost od 0.0 do 1.0 pro kad gen chromosomu, v zvyslosti na kdovn je teba zmnit
		LinkedList<Jedinec> zmutovaniJedinci = new LinkedList<>();
		double anoNe; // bude urovat hranici mutace
		LinkedList<Object> novyChromosom;
		for(Jedinec j : kMutaci){ // mutujeme kadho jedince
			novyChromosom = new LinkedList<>();
			for(Object o : j.chromosom){ // mutujeme kad gen
				anoNe = ran.nextDouble(); 
				if(anoNe < pravdepodobnost){ // bu budeme mutovat
					int pom = ran.nextInt(4);
					novyChromosom.add((Object) (pom));
				}else{ // nebo nechvme nezmnn
					novyChromosom.add(o);					
				}
			}
			zmutovaniJedinci.add(new MujJedinec(novyChromosom, j.ID,Bludiste.start));
		}		
		return zmutovaniJedinci;
	}	
	//<-- kc mechanizmy
	
	//evoluce
	public void krokEvoluce(){
		LinkedList<Jedinec> seznam = new LinkedList<>(); // nov generace
		seznam = ruletovaSelekce(generace.size(), generace);
		seznam = jednobodoveKrizeniProStejneDlouheChromozomy(seznam);
		seznam = mutace(seznam, 0.1);
		
		if(APP.tick % APP.zvetsovatPoXGeneraci == 0){ // jestli u nemme zvtovat
			seznam = zvetsitChromozomyOJeden(seznam);			
		}
		
		generace.clear();
		generace = seznam;
		ohodnotitPopulaci();
	}		
	//<-- evoluce	
	//<-- fce
	
	//konstrukory
	public Populace(int velikostPopulace, int veliksotChromosomu) { // vytvo novou populaci a ohodnot
		generace = new LinkedList<>();
		LinkedList<Object> chromosom; // pro novho jedince
		for(int i = 0; i<velikostPopulace;i++){ // v kadm cyklu nov jedinec
			chromosom = new LinkedList<>();
			for(int o = 0; o < veliksotChromosomu; o++){ // v kadm cyklu nov alela
				int p = ran.nextInt(4);
				chromosom.add((Object) p);
			}	
			generace.add(new MujJedinec(chromosom,Bludiste.start));	
		}
		ohodnotitPopulaci();
	}
	//<-- konstrukory
}

